﻿package  
{
	import net.flashpunk.World;
	import net.flashpunk.FP;
	import net.flashpunk.graphics.Text;
	import net.flashpunk.Graphic;
	import net.flashpunk.graphics.Backdrop;
	import net.flashpunk.utils.Input;
	import net.flashpunk.utils.Key;
	import net.flashpunk.utils.Draw;
	import net.flashpunk.utils.Ease;
	import net.flashpunk.Sfx;
	
	public class l_Game extends World
	{
		[Embed(source = 'bgred.png')] private const BGR:Class;
		[Embed(source = 'bgblue.png')] private const BGB:Class;
		
		public var _emitter:e_Particle;
		
		public var round:Number = 1;
		public var timer:Number = 0;
		public var rtime:Number = 0;
		public var intro:Number = 60;
		public var p1ready:Boolean = false;
		public var p2ready:Boolean = false;
		public var outro:Number = 0;
		public var hp:Number = 500;
		
		public var comptime:Number = 0;
		public var compreal:Number = 0;
		public var comphp:Number = 0;
		public var gameended:Boolean = false;

		public var runanim:Number = 0;
		public var twitchanim:Number = 0;
		public var guardanim:Number = 0;

		public var t:Text;
		public var bdrop:Backdrop;
	
		public function l_Game(r:Number,chp:Number=0,ctime:Number=0,creal:Number=0) {
			round=r;
			if (r==2) {
				comptime=ctime;
				compreal=creal;
				comphp=chp;
			}

			if (r==1) bdrop = new Backdrop(BGB);
			else bdrop = new Backdrop(BGR);
			//addGraphic(bdrop);

			_emitter = add(new e_Particle()) as e_Particle;
		}

		public override function begin():void {
			FP.screen.color = 0xFFFFFF;
			if (round==1) {
				Input.define("tapkey", Key.C);
				Input.define("p1key1", Key.Q);
				Input.define("p1key2", Key.W);
				Input.define("p1key3", Key.E);
				Input.define("p1key4", Key.R);
				Input.define("p1key5", Key.A);
				Input.define("p1key6", Key.S);
				Input.define("p1key7", Key.D);
				Input.define("p1key8", Key.F);
				Input.define("p2key1", Key.U);
				Input.define("p2key2", Key.I);
				Input.define("p2key3", Key.O);
				Input.define("p2key4", Key.P);
				Input.define("p2key5", Key.H);
				Input.define("p2key6", Key.J);
				Input.define("p2key7", Key.K);
				Input.define("p2key8", Key.L);
			} else {
				Input.define("tapkey", Key.N);
				Input.define("p1key1", Key.U);
				Input.define("p1key2", Key.I);
				Input.define("p1key3", Key.O);
				Input.define("p1key4", Key.P);
				Input.define("p1key5", Key.H);
				Input.define("p1key6", Key.J);
				Input.define("p1key7", Key.K);
				Input.define("p1key8", Key.L);
				Input.define("p2key1", Key.Q);
				Input.define("p2key2", Key.W);
				Input.define("p2key3", Key.E);
				Input.define("p2key4", Key.R);
				Input.define("p2key5", Key.A);
				Input.define("p2key6", Key.S);
				Input.define("p2key7", Key.D);
				Input.define("p2key8", Key.F);
			}
			
			if (round==1) t=new Text("PLAYER 1\nYou are the escaping player!\n\nPLAYER 2\nYou are the villain!\n\n\nGET READY! Press your tap key!",0,0);
			else if (round==2) {
				if (comptime>=3600) t=new Text("PLAYER 1\nYou are the villain!\n\nPLAYER 2\nYou are the escaping player!\nReach the finish faster than Player 1 to win!\n\n\nGET READY! Press your tap key!",0,0);
				else t=new Text("PLAYER 1\nYou are the villain!\n\nPLAYER 2\nYou are the escaping player!\nGet farther than Player 1 to win!\n\n\nGET READY! Press your tap key!",0,0);
			}
			t.color=0x000000;
		}
		
		public override function update():void {
			if (intro>0) {
				if (Input.pressed(Key.C)) p1ready=true;
				if (Input.pressed(Key.N)) p2ready=true;
				if (p1ready && p2ready) intro--;
				
				if (round==1) t.text = "PLAYER 1"+((p1ready) ? " - READY" : "")+"\nYou are the escaping player!\n\nPLAYER 2"+((p2ready) ? " - READY" : "")+"\nYou are the villain!"+((p1ready && p2ready) ? "" : "\n\n\nGET READY! Press your tap key!");
				else if (round==2) {
					if (comptime>=3600) t.text = "PLAYER 1"+((p1ready) ? " - READY" : "")+"\nYou are the villain!\n\nPLAYER 2"+((p2ready) ? " - READY" : "")+"\nYou are the escaping player!\nReach the finish faster than Player 1 to win!"+((p1ready && p2ready) ? "" : "\n\n\nGET READY! Press your tap key!");
					else t.text = "PLAYER 1"+((p1ready) ? " - READY" : "")+"\nYou are the villain!\n\nPLAYER 2"+((p2ready) ? " - READY" : "")+"\nYou are the escaping player!\nGet farther than Player 1 to win!"+((p1ready && p2ready) ? "" : "\n\n\nGET READY! Press your tap key!");
				}
			} else if (outro>0) {
				outro++;
				if (outro==60) {
					if (round==1) FP.world = new l_Game(2,hp,timer,rtime);
					else if (!gameended) {
						gameended=true;
						if (comptime>=3600) {
							if (timer<3600) t.text = "P1 WINS: P2 did not complete";
							else {
								if (compreal>rtime) t.text = "P2 WINS: Both completed, P2 faster";
								else if (compreal<rtime) t.text = "P1 WINS: Both completed, P1 faster";
								else {
									if (hp>comphp) t.text = "P2 WINS: Both completed with same time, P2 more HP";
									else if (hp<comphp) t.text = "P1 WINS: Both completed with same time, P1 more HP";
									else t.text = "TIE: Both completed with same time and same HP";
								}
							}
						} else {
							if (timer>comptime) t.text = "P2 WINS: Got farther";
							else if (timer<comptime) t.text = "P1 WINS: Got farther";
							else {
								if (hp>comphp) t.text = "P2 WINS: Both got same distance, P2 more HP";
								else if (hp<comphp) t.text = "P1 WINS: Both got same distance, P1 more HP";
								else t.text = "TIE: Both got same distance with same HP";
							}
						}
					}
				}
			} else {
				super.update();
				runanim++;
				if (runanim>=30) runanim=0;
				if (twitchanim>0 && twitchanim<15) twitchanim++;
				if (guardanim>0 && guardanim<30) guardanim++;

				if (Input.pressed("tapkey")) timer+=2;
				else timer++;
				rtime++;
				if (timer>=3600 || hp<=0) {
					outro=1;
				}
				bdrop.x-=5;

				if (timer<=360) {
					if (Math.floor(timer)%120==0) add(new e_Fireball(Math.floor(Math.random()*8)+1));
				} else if (timer<=1800) {
					if (Math.floor(timer)%60==0) add(new e_Fireball(Math.floor(Math.random()*8)+1));
				} else {
					if (Math.floor(timer)%30==0) add(new e_Fireball(Math.floor(Math.random()*8)+1));
				}

				if (Input.pressed("p1key1")||Input.pressed("p1key2")||Input.pressed("p1key3")||Input.pressed("p1key4")||Input.pressed("p1key5")||Input.pressed("p1key6")||Input.pressed("p1key7")||Input.pressed("p1key8")) {
					var hitany:Boolean = false;
					var list:Array = [];
					FP:getClass(e_Fireball,list);
					list.reverse();
					for each (var f:e_Fireball in list) {
						if (Input.pressed("p1key"+f.keynum) && f.p1time==0 && !hitany) {
							f.p1time=timer;
							hitany=true;
							break;
						}
					}
				}	
				if (Input.pressed("p2key1")||Input.pressed("p2key2")||Input.pressed("p2key3")||Input.pressed("p2key4")||Input.pressed("p2key5")||Input.pressed("p2key6")||Input.pressed("p2key7")||Input.pressed("p2key8")) {
					var hitany:Boolean = false;
					var list:Array = [];
					FP:getClass(e_Fireball,list);
					list.reverse()
					for each (var f:e_Fireball in list) {
						if (Input.pressed("p2key"+f.keynum) && f.p2time==0 && !hitany) {
							hitany=true;
							f.p2time=timer;
						}
					}
					if (!hitany && list[0]) list[0].destroy();
				}

				t.text="\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n                              "+hp+" HP left";
			}
		}
		public function onImpact(t1:Number,t2:Number) {
			_emitter.emitExplosion(400,500);
			var diff:Number;
			if (t1==0) diff=50;
			else if (t1<=t2) return;
			else {
				diff = t1-t2;
				if (diff>30) diff=30;
			}
			FP.console.log(diff);
			hp-=Math.ceil(diff/8);
			if (hp<0) hp=0;
			twitchanim=1;
			timer-=60;
		}

		public override function render():void {
			Draw.graphic(bdrop as Graphic,0,0);

			super.render();

			var col:uint = 0xFF0000;
			if (round==2) col=0x0000FF;
			var a:Number = FP.scale(Ease.cubeInOut(Math.abs(runanim-15)/15),0,1,Math.PI*0.07,Math.PI*0.83);
			Draw.linePlus(400,500,400+Math.cos(a)*30,500+Math.sin(a)*30,col,1,2);
			var b:Number = FP.scale(Math.abs(runanim-15)/15,0,1,Math.PI*0.57,Math.PI*0.9);
			Draw.linePlus(400+Math.cos(a)*30,500+Math.sin(a)*30,400+Math.cos(a)*30+Math.cos(b)*30,500+Math.sin(a)*30+Math.sin(b)*30,col,1,2);
			a = FP.scale(Ease.cubeInOut(Math.abs(runanim-15)/15),1,0,Math.PI*0.07,Math.PI*0.83);
			Draw.linePlus(400,500,400+Math.cos(a)*30,500+Math.sin(a)*30,col,1,2);
			b = FP.scale(Math.abs(runanim-15)/15,1,0,Math.PI*0.57,Math.PI*0.9);
			Draw.linePlus(400+Math.cos(a)*30,500+Math.sin(a)*30,400+Math.cos(a)*30+Math.cos(b)*30,500+Math.sin(a)*30+Math.sin(b)*30,col,1,2);

			a = FP.scale(Math.abs(twitchanim-7.5)/7.5,1,0,FP.scale(Ease.cubeInOut(Math.abs(runanim-15)/15),1,0,Math.PI*1.65,Math.PI*1.62),Math.PI*1.85);
			Draw.linePlus(400,500,400+Math.cos(a)*20,500+Math.sin(a)*20,col,1,2);
			b = FP.scale(Ease.cubeInOut(Math.abs(runanim-15)/15),1,0,Math.PI*1.75,Math.PI*1.72);
			Draw.linePlus(400+Math.cos(a)*20,500+Math.sin(a)*20,400+Math.cos(a)*20+Math.cos(b)*20,500+Math.sin(a)*20+Math.sin(b)*20,col,1,2);
			Draw.circlePlus(400+Math.cos(a)*20+Math.cos(b)*35,500+Math.sin(a)*20+Math.sin(b)*35,15,col,1,false,2);

			var c:Number = FP.scale(Ease.cubeInOut(Math.abs(runanim-15)/15),0,1,Math.PI*0.15,Math.PI*1.05);
			Draw.linePlus(400+Math.cos(a)*20+Math.cos(b)*20,500+Math.sin(a)*20+Math.sin(b)*20,400+Math.cos(a)*20+Math.cos(b)*20+Math.cos(c)*30,500+Math.sin(a)*20+Math.sin(b)*20+Math.sin(c)*30,col,1,2);
			Draw.linePlus(400+Math.cos(a)*20+Math.cos(b)*20+Math.cos(c)*30,500+Math.sin(a)*20+Math.sin(b)*20+Math.sin(c)*30,400+Math.cos(a)*20+Math.cos(b)*20+Math.cos(c)*30+Math.cos(c-Math.PI*0.5)*30,500+Math.sin(a)*20+Math.sin(b)*20+Math.sin(c)*30+Math.sin(c-Math.PI*0.5)*30,col,1,2);
			c = FP.scale(Ease.cubeInOut(Math.abs(runanim-15)/15),1,0,Math.PI*0.15,Math.PI*1.05);
			Draw.linePlus(400+Math.cos(a)*20+Math.cos(b)*20,500+Math.sin(a)*20+Math.sin(b)*20,400+Math.cos(a)*20+Math.cos(b)*20+Math.cos(c)*30,500+Math.sin(a)*20+Math.sin(b)*20+Math.sin(c)*30,col,1,2);
			Draw.linePlus(400+Math.cos(a)*20+Math.cos(b)*20+Math.cos(c)*30,500+Math.sin(a)*20+Math.sin(b)*20+Math.sin(c)*30,400+Math.cos(a)*20+Math.cos(b)*20+Math.cos(c)*30+Math.cos(c-Math.PI*0.5)*30,500+Math.sin(a)*20+Math.sin(b)*20+Math.sin(c)*30+Math.sin(c-Math.PI*0.5)*30,col,1,2);

			Draw.graphic(t as Graphic,30,100);
		}
	}
}
